
%%% function.pl

%%% Prosty program ilustrujcy ide definiowania i wyliczanie funkcji w Prologu.
%%% Przekazywanie danych za pomoca skadania podstawie.

%%% Fakty: definicja pewnej funkcji
%%% function(<input>,<output>).

function(1,1).
function(2,2).
function(3,3).
function(4,5).
function(5,7).
function(6,11).
function(7,13).
function(8,17).
function(9,19).
function(10,23).
function(11,29).
function(12,31).
function(13,37).

%% Trzykrotne zloenie funkcji; zwrot wartoci przez parametr:
f3(X,Y):-
   function(X,Y1),
   function(Y1,Y2),
   function(Y2,Y).

%%% Trzykrotne zloenie funkcji; zwrot wartoci przez wypis:
f3w(X):-
   function(X,Y1),
   function(Y1,Y2),
   function(Y2,Y),
   write(Y),nl.

%%% Trzykrotne zloenie funkcji; zwrot wartoci przez assert:
f3a(X):-
   function(X,Y1),
   function(Y1,Y2),
   function(Y2,Y),
   assert(f3a(X,Y)),fail.

