%%% liczby-send.pl

%%% Prosty program ilustrujcy ide generacji/wyszukiwania rozwiza w Prologu
%%% i zastosowania do generowania cakowitoliczbowych rozwiza ukadu rwna

% Fakty: definicja dostpnych cyfr. 
   cyfra(0).
   cyfra(1).
   cyfra(2).
   cyfra(3).
   cyfra(4).
   cyfra(5).   
   cyfra(6).
   cyfra(7).
   cyfra(8).
   cyfra(9).

solve(X,Y,Z,U):-
   cyfra(X),cyfra(Y),cyfra(Z),cyfra(U),
   Z is X+Y,
   U is X-Y,
   Q1 is Z+U,
   Q2 is X*Y,
   Q is Q1-Q2,
   Q =:= 0.

best :-
  solve(X,Y,Z,U),
  M is X+Y+Z+U,!, 
  search(M).
search(M):-
  solve(X,Y,Z,U), /* tu sa znajd. stare rozw. (powtarzanie); fail lepszy */
  N is X+Y+Z+U,
  N>M,!,
  write(N),nl,
  search(N).  
search(V) :- write('Optimal V = '), write(V).  
     




% Modyfikacje:
% 1. Podstawianie za zmiennegotowych  wartoci. Np. M=1 zamiast c(M).
% 2. Zmiana kolejnoci podstawie i ogranicze (przeplatanie).
% 3. Pobieranie wartoci z listy z usuwaniem pobranych wartoci.
% 4. Wprowadzenie nowych regu ogranicze.

% eof
