%%% Wyznaczanie minimalnego elementu z listy

    min([X],X):-!.
    min([P|R],P):- min(R,X),X > P,!.
    min([P|R],X):- min(R,X),X =< P.

%%% Sortowanie poprzez sekwencyjny wybr maksimum
    max([X],X):-!.
    max([P|R],P):- max(R,X),X =< P,!.
    max([P|R],X):- max(R,X),X > P.

    min-sort([],[]):-!.
    min-sort(L,[M|LS]):- min(L,M),select(M,L,LM),!,min-sort(LM,LS).

    min-sort-iter(L,LS):- msi(L,[],LS).

    msi([],LS,LS):- !.
    msi(L,LA,LS):- max(L,M),write(M),nl,select(M,L,LM),!,msi(LM,[M|LA],LS),write([M|LA]),nl.




    
%% minimum iteracyjne

    mini([X|T],MIN,MINI):-
       X<MIN,!,
       mini(T,X,MINI).
    mini([_|T],MIN,MINI):-
       mini(T,MIN,MINI).
    mini([],MINI,MINI).

% Zadania:
% 1. Zbuduj inne minimum iteracyjne.
% 2. Znajd min i max w jednym obiegu.
% 3. Zbuduj minimum z fail (ptla z fail na kocu).
