on(a,b).
on(b,c).
on(c,d).
on(d,e).

on(a1,b1).
on(b1,c1).
on(c1,d1).
on(d1,e1).

onfloor(e).
onfloor(e1).

above(X,Z) :- on(X,Z).
above(X,Z) :- on(X,Y), above(Y,Z).

floor(X,0) :- onfloor(X).
floor(X,N) :- on(X,Y), floor(Y,N1), N is N1+1.

match(X,Y) :- floor(X,NX), floor(Y,NY), X \= Y, NX=NY.

