%%% Fibonacci: klasyczna rekurencja

fibrec(0,0).
fibrec(1,1).

fibrec(N,M):- 
  N1 is N-1, N1>=0,
  N2 is N-2, N2>=0,
  fibrec(N1,M1),
  fibrec(N2,M2),!,
  M is M1+M2.

%%% Fibonacci - wersja iteracyjna (R. Bartak; ALi)

fibiter(N,F):-fibi(0,0,1,N,F).
   

fibi(N1,F1,F2,N,F):-
  N1<N,!,		  % test braku końca obliczeń
  N2 is N1+1,   	  % inkrementacja licznika
  F3 is F1+F2,		  % kolejny wyraz ciagu
  fibi(N2,F2,F3,N,F).     % "koniec-woła-poczatek" dla nowych parametrów

fibi(N,F,_,N,F).

%%% Fibonacci - wersja loop-assert-fail. Wykorzystanie nawrotów.












