%%% Program liczenia silni z wykorzystanie ptli repeat-fail

:- dynamic(silnia/2).
 
go(N,Wynik):-
 retractall(silnia(_,_)),
 assert(silnia(0,1)),
 licz(N,Wynik). 

     licz(N,Wynik) :-
        nawrot(N),
        silnia(K,W),
        K1 is K+1,
        Wynik is W*K1,
        write(K1), write('   '), write(Wynik),nl, 
       retract(silnia(K,W)),
        asserta(silnia(K1,Wynik)),
        fail.
  
     licz(N,Wynik):- silnia(N,Wynik),write(Wynik).


%%% Redefinicja repeat (nawwrt warunkowy).

nawrot(N):- silnia(K,_), K >= N,!, fail.
nawrot(N):- silnia(K,_), K < N.
nawrot(N):- silnia(K,_), K < N, nawrot(N).



%%% eof

